#include <stdio.h>
#include <string.h>
#include "auxiliar.h"

int check_length(char **inputs, uint8_t num_inputs)
{
	int input_length = strlen(inputs[0]);
    if((input_length != strlen(inputs[1])) || (strlen(inputs[2]) != 1))
    {
    	return -1;
    }
    return input_length;
}

int main(int argc, char **argv)
{
	if(argc != 2)
	{
		error();
	}
	char *input = argv[1];
	if(!strcmp(input,"error"))
	{
		error();
	}
	char **inputs = comma_separate(input);
	if(inputs == NULL)
	{
		error();
	}
	int num_inputs = num_occurrences(input,',');
	if(num_inputs != 3)
	{
		error();
	}
	int input_length = check_length(inputs,num_inputs);
	if(input_length == -1)
	{
		error();
	}
	int a,b,carry_in,c;
	a = bin2udec(inputs[0]);
	b = bin2udec(inputs[1]);
	carry_in = bin2udec(inputs[2]);
	c = a+b+carry_in;
	char *result = dec2bin(c,input_length+1);
	printf("%s,%c",result+1,result[0]);
	free(result);
	free_mem(inputs,num_inputs);
	return 0;
}
