#include <stdio.h>
#include <string.h>
#include "auxiliar.h"

int check_length(char **inputs, uint8_t num_inputs)
{
	int input_length = strlen(inputs[0]);
	int i;
	for(i = 1; i < num_inputs; i++)
	{
		if(input_length != strlen(inputs[i]))
		{
			return -1;
		}
	}
	int max_value = 1;
	int max_bits = num_inputs * input_length;
    i = 0;
    while(max_value <= max_bits)
    {
    	max_value = 0x1 << ++i;
    }
    return i;
}

int main(int argc, char **argv)
{
	int i;
	if(argc != 2)
	{
		error();
	}
	char *input = argv[1];
	if(!strcmp(input,"error"))
	{
		error();
	}
	char **inputs = comma_separate(input);
	if(inputs == NULL)
	{
		error();
	}
	int num_inputs = num_occurrences(input,',');
	int input_length = check_length(inputs,num_inputs);
	int count = 0;
	for(i = 0; i < num_inputs; i++)
	{
		count += count_bits(inputs[i]);
	}
	char *result = dec2bin(count,input_length);
	printf("%s",result);
	free(result);
	free_mem(inputs,num_inputs);
	return 0;
}
